header {
package texToJoc;
}

class TexToPmlParser extends Parser;
options {
   k = 1;
}

{  GestionPml maGestionPml;
}

file  : enTete listExpressions
      ;

enTete : (debutDoc)? { maGestionPml.premiereChaine(); } ;

debutDoc : DEBUT_DOCUMENT { maGestionPml.debutDoc(); } ;
//=================== expression =========
listExpressions :  (instruc)+ ;
instruc   :  expression | uneFormule ;
expression
   : leHeader
   | unSingleton
   | chainePurePoliceeEmpilee
//   | listeDeChaines | chaineParagraphee
   | chaineParagraphee
   | contexteTheoreme
//   | lesListes
   | ligneCentree
//   | lesSections
   ;
//=============== caracteres de base =====
//leRetourTexte  :  LE_RETOUR     { maGestionPml.leRetourTexte(); } ;
blanc          :  BLANC         { maGestionPml.blanc(); } ;
blancForce     : (BLANC_FORCE | ESPACE) { maGestionPml.blancForce(); } ;
//=== lettres accentues ==
lettreAccentue : A_GRAVE         { maGestionPml.lettreAccentue('\u00E0'); }
               | A_AIGU          { maGestionPml.lettreAccentue('\u00E1'); }
               | A_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00E2'); }
               | A_TILDE         { maGestionPml.lettreAccentue('\u00E3'); }
               | A_TREMA         { maGestionPml.lettreAccentue('\u00E4'); }
               | A_ROND          { maGestionPml.lettreAccentue('\u00E5'); }

               | E_GRAVE         { maGestionPml.lettreAccentue('\u00E8'); }
               | E_AIGU          { maGestionPml.lettreAccentue('\u00E9'); }
               | E_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00EA'); }
               | E_TREMA         { maGestionPml.lettreAccentue('\u00EB'); }

               | I_GRAVE         { maGestionPml.lettreAccentue('\u00EC'); }
               | I_AIGU          { maGestionPml.lettreAccentue('\u00ED'); }
               | (I_CIRCONFLEXE |
                  I_CIRCONFLEXE_PAR) { maGestionPml.lettreAccentue('\u00EE'); }
               | I_TREMA         { maGestionPml.lettreAccentue('\u00EF'); }

               | O_GRAVE         { maGestionPml.lettreAccentue('\u00F2'); }
               | O_AIGU          { maGestionPml.lettreAccentue('\u00F3'); }
               | O_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00F4'); }
               | O_TILDE         { maGestionPml.lettreAccentue('\u00F5'); }
               | O_TREMA         { maGestionPml.lettreAccentue('\u00F6'); }

               | U_GRAVE         { maGestionPml.lettreAccentue('\u00F9'); }
               | U_AIGU          { maGestionPml.lettreAccentue('\u00FA'); }
               | U_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00FB'); }
               | U_TREMA         { maGestionPml.lettreAccentue('\u00FC'); }

               | C_CEDILLE       { maGestionPml.lettreAccentue('\u00E7'); }
               | N_TILDE         { maGestionPml.lettreAccentue('\u00F1'); }

               | AM_GRAVE         { maGestionPml.lettreAccentue('\u00C0'); }
               | AM_AIGU          { maGestionPml.lettreAccentue('\u00C1'); }
               | AM_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00C2'); }
               | AM_TILDE         { maGestionPml.lettreAccentue('\u00C3'); }
               | AM_TREMA         { maGestionPml.lettreAccentue('\u00C4'); }
               | AM_ROND          { maGestionPml.lettreAccentue('\u00C5'); }

               | EM_GRAVE         { maGestionPml.lettreAccentue('\u00C8'); }
               | EM_AIGU          { maGestionPml.lettreAccentue('\u00C9'); }
               | EM_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00CA'); }
               | EM_TREMA         { maGestionPml.lettreAccentue('\u00CB'); }

               | IM_GRAVE         { maGestionPml.lettreAccentue('\u00CC'); }
               | IM_AIGU          { maGestionPml.lettreAccentue('\u00CD'); }
               | IM_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00CE'); }
               | IM_TREMA         { maGestionPml.lettreAccentue('\u00CF'); }

               | OM_GRAVE         { maGestionPml.lettreAccentue('\u00D2'); }
               | OM_AIGU          { maGestionPml.lettreAccentue('\u00D3'); }
               | OM_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00D4'); }
               | OM_TILDE         { maGestionPml.lettreAccentue('\u00D5'); }
               | OM_TREMA         { maGestionPml.lettreAccentue('\u00D6'); }

               | UM_GRAVE         { maGestionPml.lettreAccentue('\u00D9'); }
               | UM_AIGU          { maGestionPml.lettreAccentue('\u00DA'); }
               | UM_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00DB'); }
               | UM_TREMA         { maGestionPml.lettreAccentue('\u00DC'); }

               | CM_CEDILLE       { maGestionPml.lettreAccentue('\u00C7'); }
               | NM_TILDE         { maGestionPml.lettreAccentue('\u00D1'); }
//=== speciales ===
               | LE_MOINS         { maGestionPml.lettreAccentue('-'); }
               ;
caracteresMathML : inferieur | superieur | lOblique
                 ;
inferieur   :  INFERIEUR   { maGestionPml.caracteresMathML('<'); } ;
superieur   :  SUPERIEUR   { maGestionPml.caracteresMathML('>'); } ;
lOblique    :  L_OBLIQUE   { maGestionPml.caracteresMathML('/'); } ;

caractere
   : (st : CARACTERE { maGestionPml.caractere(st.getText()); } )
   ;
caractereAccentue
   : (st : CARACTERE_ACCENTUE
               { maGestionPml.caractereAccentue(st.getText()); } )
   ;
caractereComplet
   :  caractere | caractereAccentue
   | caracteresMathML
   | blanc | blancForce //| leRetourTexte
   | lettreAccentue | lesReferences
   | changementPermanentDePolice | ECART_HORIZONTAL
   | chainePureSoulignee | chaineParenthesee | lesSections | item
   | lesReserves
   | tailleScript
   | ressort
   | accentueMath
   | lesFaussesBbb | lesFaussesBbbDirects
   | listeDeChaines

   ;
caractereCompletMath
   :  caractere | caractereAccentue
   | caracteresMathML
   | blanc | blancForce //| leRetourTexte
   | lettreAccentue | lesReferences
   | changementPermanentDePolice | ECART_HORIZONTAL
   | chainePureSoulignee | lesSections | item
   | lesReserves
   | tailleScript
   | ressort
   | accentueMath
   ;
//======================== Singletons ==============================
unSingleton
   :  finParagraphe | finDuDocument //| overline
   ;
finParagraphe : FINPARAG   { maGestionPml.finParagraphe(); } ;

finDuDocument : (LE_END | FIN_DOCUMENT) { maGestionPml.finDuDocument(); } ;
//=== fermeture de groupe: remettre taille normale ===
rAccolade   :  R_ACCOLADE           { maGestionPml.tailleNormale(); }
         ;
//========== ligneCentree =========
ligneCentree : LIGNE_CENTREE  { maGestionPml.ligneCentree(); }
//               listExpressions
               (caractereComplet | uneFormule)+
               rAccolade        { maGestionPml.finLigneCentree(); } ;
//============== chaine basique =======================
chainePureSoulignee
            :  UNDERLINE L_ACCOLADE
               //listeDeChaines
               chainePure
               rAccolade
               { maGestionPml.chainePureSoulignee(); } ;

chainePure { maGestionPml.nouvelleChaine(); }
   :  (caractereComplet)+
   ;
chaineParagraphee : { maGestionPml.chaineParagraphee(); }
      chainePure (chainePurePoliceeEmpilee
                  | uneFormule
                  | finParagraphe) ;
chainePenchee  : (PL_PENCHEE_EMP | L_PENCHEE_EMP)
                                       { maGestionPml.debChaineFormee(); }
                  chainePure rAccolade { maGestionPml.chainePenchee(); } ;
chaineGraissee :
         (PL_GRASSE_EMP | L_GRASSE_EMP)
                              { maGestionPml.debChaineFormee(); }
         chainePure rAccolade { maGestionPml.chaineGraissee(); } ;
chaineGraisseeFormee
 : (L_GRASSE_PENCHEE_EMP | PL_GRASSE_PENCHEE_EMP)
                              { maGestionPml.debChaineFormee(); }
         chainePure rAccolade rAccolade
                  { maGestionPml.chaineFormeeGraissee(); } ;
chaineFormeeGraissee
 : (L_PENCHEE_GRASSE_EMP | PL_PENCHEE_GRASSE_EMP)
                           { maGestionPml.debChaineFormee(); }
         chainePure rAccolade rAccolade
                           { maGestionPml.chaineFormeeGraissee(); } ;
listeDeChaines
 : chainePenchee | chaineGraissee
 | chaineGraisseeFormee | chaineFormeeGraissee
 ;
chainePurePoliceeEmpilee
   :  unePureOuverturePolice
      ( chainePure      |
         (listeDeChaines)+ )
      rAccolade        { maGestionPml.chainePurePoliceeEmpilee(); } ;

expressionPureParenthesee :  L_ACCOLADE listExpressions rAccolade ;
//                     { maGestionPml.expressionParenthesee(); } ;
chaineParenthesee :  { maGestionPml.chaineParentheseeEntree(); }
                     L_ACCOLADE chainePure rAccolade
                     { maGestionPml.chaineParenthesee(); } ;
//============== polices =================
unePureOuverturePolice
   : (PL_ROMAN_EMP    | L_ROMAN_EMP)
         { maGestionPml.unePureOuverturePolice(Globale.ROMAN); }
   | (PL_SMALLCAP_EMP | L_SMALLCAP_EMP)
         { maGestionPml.unePureOuverturePolice(Globale.SMALLCAP); }
   | (PL_BLACKBOARD_EMP | L_BLACKBOARD_EMP)
         { maGestionPml.unePureOuverturePolice(Globale.BLACKBOARD); }
   | (PL_ITALIC_EMP  | L_ITALIC_EMP)
         { maGestionPml.unePureOuverturePolice(Globale.ITALIC); }
   | (PL_GOTHIC_EMP  | L_GOTHIC_EMP)
         { maGestionPml.unePureOuverturePolice(Globale.GOTHIC); }
   | (PL_CALLIGRAPHIC_EMP | L_CALLIGRAPHIC_EMP)
         { maGestionPml.unePureOuverturePolice(Globale.CALLIGRAPHIC); }
//   | (PL_TYPEWRITER_EMP | L_TYPEWRITER_EMP)
  //       { maGestionPml.unePureOuverturePolice(Globale.TYPEWRITER); }
   | CYRILLIC_EMP
         { maGestionPml.unePureOuverturePolice(Globale.CYRILLIC); }
   ;
//======================= permanente ===========================
changementPermanentDePolice
   :  changementRoman | changementAutres
   ;

changementRoman
   :  roman | romanSlanted | romanBold
   | romanSlantedBold ;
roman            : ROMAN                { maGestionPml.roman(0); } ;
romanSlanted     : SLANTED_TEX          { maGestionPml.roman(1); } ;
romanBold        : BOLDFACE_TEX         { maGestionPml.roman(2); } ;
romanSlantedBold : SLANTED_BOLDFACE_TEX { maGestionPml.roman(3); } ;

changementAutres
   : blackBoard | italic | gothic | callig //| typeWriter
   | smallCap   | cyrillic
   ;
blackBoard  : BLACKBOARD         { maGestionPml.blackBoard(); } ;
italic      : ITALIC             { maGestionPml.italic(); } ;
gothic      : GOTHIC             { maGestionPml.gothic(); } ;
callig      : CALLIGRAPHIC       { maGestionPml.callig(); } ;
//typeWriter  : TYPEWRITER         { maGestionPml.typeWriter(); } ;
smallCap    : SMALLCAP           { maGestionPml.smallCap(); } ;
cyrillic    : CYRILLIC           { maGestionPml.cyrillic(); } ;
tailleScript   :  TAILLE_SCRIPT  { maGestionPml.tailleScript(); } ;
//================ divers ============
//================ grec ==============
//================ grec ==============
caracteresGrecsDirects
   : alpha | beta | chi | delta | epsilon | varepsilon | phi
   | varphi | gamma | eta | iota | kappa | lambda | mu | nu
   | omega | pi | psi | rho | varrho | sigma | tau | theta
   | vartheta | upsilon | xi | zeta
   ;
alpha       :  A_GREC   { maGestionPml.lettreGrecque('a'); } ;
beta        :  B_GREC   { maGestionPml.lettreGrecque('b'); } ;
chi         :  C_GREC   { maGestionPml.lettreGrecque('c'); } ;
delta       :  D_GREC   { maGestionPml.lettreGrecque('d'); } ;
epsilon     :  E_GREC   { maGestionPml.lettreGrecque('e'); } ;
varepsilon  :  EE_GREC  { maGestionPml.lettreGrecque('e'); } ;
phi         :  F_GREC   { maGestionPml.lettreGrecque('f'); } ;
varphi      :  FF_GREC  { maGestionPml.lettreGrecque('f'); } ;
gamma       :  G_GREC   { maGestionPml.lettreGrecque('g'); } ;
eta         :  H_GREC   { maGestionPml.lettreGrecque('h'); } ;
iota        :  I_GREC   { maGestionPml.lettreGrecque('i'); } ;
kappa       :  K_GREC   { maGestionPml.lettreGrecque('k'); } ;
lambda      :  L_GREC   { maGestionPml.lettreGrecque('l'); } ;
mu          :  M_GREC   { maGestionPml.lettreGrecque('m'); } ;
nu          :  N_GREC   { maGestionPml.lettreGrecque('n'); } ;
pi          :  P_GREC   { maGestionPml.lettreGrecque('p'); } ;
psi         :  Q_GREC   { maGestionPml.lettreGrecque('q'); } ;
rho         :  R_GREC   { maGestionPml.lettreGrecque('r'); } ;
varrho      :  RR_GREC  { maGestionPml.lettreGrecque('r'); } ;
sigma       :  S_GREC   { maGestionPml.lettreGrecque('s'); } ;
varsigma    :  SS_GREC  { maGestionPml.lettreGrecque('s'); } ;
tau         :  T_GREC   { maGestionPml.lettreGrecque('t'); } ;
theta       :  TT_GREC  { maGestionPml.lettreGrecque('t'); } ;
vartheta    :  TTT_GREC { maGestionPml.lettreGrecque('t'); } ;
upsilon     :  U_GREC   { maGestionPml.lettreGrecque('u'); } ;
omega       :  W_GREC   { maGestionPml.lettreGrecque('w'); } ;
xi          :  X_GREC   { maGestionPml.lettreGrecque('x'); } ;
zeta        :  Z_GREC   { maGestionPml.lettreGrecque('z'); } ;
// majuscules
caracteresGrecsMaj
   : deltaMaj | gammaMaj | thetaMaj | lambdaMaj | piMaj
   | xiMaj | sigmaMaj | upsilonMaj | phiMaj | psiMaj | omegaMaj
   ;
deltaMaj    :  DM_GREC   { maGestionPml.lettreGrecque('D'); } ;
gammaMaj    :  GM_GREC   { maGestionPml.lettreGrecque('G'); } ;
thetaMaj    :  TM_GREC   { maGestionPml.lettreGrecque('T'); } ;
lambdaMaj   :  LM_GREC   { maGestionPml.lettreGrecque('L'); } ;
piMaj       :  PM_GREC   { maGestionPml.lettreGrecque('P'); } ;
xiMaj       :  XM_GREC   { maGestionPml.lettreGrecque('X'); } ;
sigmaMaj    :  SM_GREC   { maGestionPml.lettreGrecque('S'); } ;
upsilonMaj  :  UM_GREC   { maGestionPml.lettreGrecque('U'); } ;
phiMaj      :  FM_GREC   { maGestionPml.lettreGrecque('F'); } ;
psiMaj      :  QM_GREC   { maGestionPml.lettreGrecque('Q'); } ;
omegaMaj    :  WM_GREC   { maGestionPml.lettreGrecque('W'); } ;

caracteresGrecs
   :  GRECS
      (st : CARACTERE { maGestionPml.lettreGrecque(st.getText()); } )
      rAccolade
   ;
//============== fausses Bbb ==================
lesFaussesBbbDirects
: aFausseBbb | bFausseBbb | cFausseBbb | dFausseBbb | eFausseBbb
| fFausseBbb | gFausseBbb | hFausseBbb | iFausseBbb | jFausseBbb
| kFausseBbb | lFausseBbb | mFausseBbb | nFausseBbb | oFausseBbb
| pFausseBbb | qFausseBbb | rFausseBbb | sFausseBbb | tFausseBbb
| uFausseBbb | vFausseBbb | wFausseBbb | xFausseBbb | yFausseBbb
| zFausseBbb | unFausseBbb
;
unFausseBbb  :  UN_BBB    { maGestionPml.lettreFausseBbb('1'); } ;
aFausseBbb  :  A_BBB    { maGestionPml.lettreFausseBbb('A'); } ;
bFausseBbb  :  B_BBB    { maGestionPml.lettreFausseBbb('B'); } ;
cFausseBbb  :  C_BBB    { maGestionPml.lettreFausseBbb('C'); } ;
dFausseBbb  :  D_BBB    { maGestionPml.lettreFausseBbb('D'); } ;
eFausseBbb  :  E_BBB    { maGestionPml.lettreFausseBbb('E'); } ;
fFausseBbb  :  F_BBB    { maGestionPml.lettreFausseBbb('F'); } ;
gFausseBbb  :  G_BBB    { maGestionPml.lettreFausseBbb('G'); } ;
hFausseBbb  :  H_BBB    { maGestionPml.lettreFausseBbb('H'); } ;
iFausseBbb  :  I_BBB    { maGestionPml.lettreFausseBbb('I'); } ;
jFausseBbb  :  J_BBB    { maGestionPml.lettreFausseBbb('J'); } ;
kFausseBbb  :  K_BBB    { maGestionPml.lettreFausseBbb('K'); } ;
lFausseBbb  :  L_BBB    { maGestionPml.lettreFausseBbb('L'); } ;
mFausseBbb  :  M_BBB    { maGestionPml.lettreFausseBbb('M'); } ;
nFausseBbb  :  N_BBB    { maGestionPml.lettreFausseBbb('N'); } ;
oFausseBbb  :  O_BBB    { maGestionPml.lettreFausseBbb('O'); } ;
pFausseBbb  :  P_BBB    { maGestionPml.lettreFausseBbb('P'); } ;
qFausseBbb  :  Q_BBB    { maGestionPml.lettreFausseBbb('Q'); } ;
rFausseBbb  :  R_BBB    { maGestionPml.lettreFausseBbb('R'); } ;
sFausseBbb  :  S_BBB    { maGestionPml.lettreFausseBbb('S'); } ;
tFausseBbb  :  T_BBB    { maGestionPml.lettreFausseBbb('T'); } ;
uFausseBbb  :  U_BBB    { maGestionPml.lettreFausseBbb('U'); } ;
vFausseBbb  :  V_BBB    { maGestionPml.lettreFausseBbb('V'); } ;
wFausseBbb  :  W_BBB    { maGestionPml.lettreFausseBbb('W'); } ;
xFausseBbb  :  X_BBB    { maGestionPml.lettreFausseBbb('X'); } ;
yFausseBbb  :  Y_BBB    { maGestionPml.lettreFausseBbb('Y'); } ;
zFausseBbb  :  Z_BBB    { maGestionPml.lettreFausseBbb('Z'); } ;

lesFaussesBbb
   :  BBB
      (st : CARACTERE { maGestionPml.lettreFausseBbb(st.getText()); } )
      rAccolade
   ;

//==================== reserves ===
lesReserves : accOuvrReserve | accFermReserve | pourcentage | leDieze ;
accOuvrReserve
   :  ACC_OUVRANTE_RESERVE { maGestionPml.lettreReserve('{'); } ;
accFermReserve
   :  ACC_FERMANTE_RESERVE { maGestionPml.lettreReserve('}'); } ;
pourcentage
   :  POUR_CENT { maGestionPml.lettreReserve('%'); } ;
leDieze
   :  LE_DIEZE  { maGestionPml.lettreReserve('#'); } ;
//======================= maths ====================================
caracteresMathsDirects
: appartient | different | croix | dPartielle | ilExiste | contient
| intersectionCar | contientEns | nonIdentique | infini | pasEn
| orthogonal | leT | unionCar | pourTout | pointCentre | similaire
| rondCentre | barreVerticale | dbleBarreVerticale | boulette
| infOuEgal | supOuEgal | croixRond | leGros | inclusion | equivalent
| leVide | exterieur | plusOuMoins | bigTriangleUp | troisPoints
| pointVertical
| ell | nabla | infTilda | semblable
;
appartient  :  APPARTIENT  { maGestionPml.lettreMath('a'); } ;
different   :  DIFFERENT   { maGestionPml.lettreMath('b'); } ;
croix       :  CROIX       { maGestionPml.lettreMath('c'); } ;
dPartielle  :  D_PARTIELLE { maGestionPml.lettreMath('d'); } ;
ilExiste    :  IL_EXISTE   { maGestionPml.lettreMath('e'); } ;
contient    :  CONTIENT    { maGestionPml.lettreMath('f'); } ;

intersectionCar :  INTERSECTION_CAR { maGestionPml.lettreMath('i'); } ;
contientEns     :  CONTIENT_ENS     { maGestionPml.lettreMath('j'); } ;
inclusion       :  INCLUSION       { maGestionPml.lettreMath('k'); } ;
ell             :  ELL            { maGestionPml.lettreMath('l'); } ;
nabla           :  NABLA         { maGestionPml.lettreMath('m'); } ;
nonIdentique   :  NON_IDENTIQUE { maGestionPml.lettreMath('n'); } ;
infini         :  INFINI        { maGestionPml.lettreMath('o'); } ;

pasEn          :  PAS_DEDANS    { maGestionPml.lettreMath('r'); } ;
orthogonal     :  ORTHOGONAL    { maGestionPml.lettreMath('s'); } ;
leT            :  LE_T          { maGestionPml.lettreMath('t'); } ;
unionCar       :  UNION_CAR     { maGestionPml.lettreMath('u'); } ;
pourTout       :  POUR_TOUT     { maGestionPml.lettreMath('v'); } ;
troisPoints    :  TROIS_POINTS  { maGestionPml.lettreMath('y'); } ;

pointVertical  :  POINT_VERTICAL { maGestionPml.lettreMath(','); } ;
pointCentre    :  POINT_CENTRE  { maGestionPml.lettreMath(','); } ;
similaire      :  SIMILAIRE     { maGestionPml.lettreMath(';'); } ;
semblable      :  SEMBLABLE     { maGestionPml.lettreMath(';'); } ;
rondCentre     :  ROND_CENTRE   { maGestionPml.lettreMath('.'); } ;
barreVerticale :  BARRE_VERTICALE  { maGestionPml.lettreMath('!'); } ;
leVide         :  VIDE          { maGestionPml.lettreMath('0'); } ;
exterieur      :  EXTERIEUR     { maGestionPml.lettreMath('1'); } ;
dbleBarreVerticale : DBARRE_VERTICALE { maGestionPml.lettreMath('5'); } ;
boulette       :  BOULETTE      { maGestionPml.lettreMath(')'); } ;
infOuEgal      :  INF_EGAL      { maGestionPml.lettreMath('<'); } ;
supOuEgal      :  SUP_EGAL      { maGestionPml.lettreMath('>'); } ;
croixRond      :  CROIX_ROND    { maGestionPml.lettreMath('*'); } ;
equivalent     :  EQUIVALENT    { maGestionPml.lettreMath('~'); } ;
plusOuMoins    :  PLUS_MOINS    { maGestionPml.lettreMath('#'); } ;
bigTriangleUp  :  BIG_TRIANGLE_UP { maGestionPml.lettreMath('#'); } ;
leGros         :  LE_GROS        ;
infTilda       :  INF_TILDA      { maGestionPml.lettreMath('<'); } ;
//========= lettre math2 =========
caracteresMath2Directs
: flecheDroite | flecheVers | implication | equivalence
| flecheSE| flecheSW| flecheNE| flecheNW
;
flecheSE       :  FLECHE_SE      { maGestionPml.lettreMath2('X'); } ;
flecheSW       :  FLECHE_SW      { maGestionPml.lettreMath2('X'); } ;
flecheNE       :  FLECHE_NE      { maGestionPml.lettreMath2('X'); } ;
flecheNW       :  FLECHE_NW      { maGestionPml.lettreMath2('X'); } ;
flecheDroite   :  FLECHE_DROITE  { maGestionPml.lettreMath2(':'); } ;
flecheVers     :  FLECHE_VERS    { maGestionPml.lettreMath2(':'); } ;
implication    :  IMPLICATION    { maGestionPml.lettreMath2(';'); } ;
equivalence    :  EQUIVALENCE    { maGestionPml.lettreMath2('='); } ;


caracteresMaths
   :  MATHS
      (st : CARACTERE { maGestionPml.lettreMath(st.getText()); } )
      rAccolade
   ;

caracteresMath2
   :  BATHS
      (st : CARACTERE { maGestionPml.lettreMath2(st.getText()); } )
      rAccolade
   ;

//========= lettre math italique =====
caracteresItaliques
: contreOblique
;
contreOblique  :  BACKSLASH      { maGestionPml.lettreItalique('\\'); } ;
//======================= le header ================================
leHeader : titre | auteur | date ;     // | sommaire ;

titre    :  LE_TITRE
            (caractereComplet | uneFormule)+ rAccolade
            { maGestionPml.titre(); } ;
auteur   :  L_AUTEUR
            (caractereComplet | uneFormule)+ rAccolade
            { maGestionPml.auteur(); } ;
date     :  LA_DATE
            (caractereComplet | uneFormule)+ rAccolade
            { maGestionPml.date(); } ;
/*
resume     :   RESUME                  { maGestionPml.resume(); }
               L_ACCOLADE listExpressions rAccolade
               FIN_RESUME              { maGestionPml.finResume(); } ;
*/
// sommaire   : LE_SOMMAIRE               { maGestionPml.sommaire(); } ;

//======================= theoreme ==============================
intitule
   : LE_BEGIN_PAR chainePure rAccolade { maGestionPml.intitule(); } ;
finIntitule
   : LE_END_PAR chainePure rAccolade { maGestionPml.finIntitule(); } ;
contexteTheoreme
 :    intitule
//      ( expressionPureParenthesee |
      listExpressions
      finIntitule ;
//contexteTheoreme
//   : intitule listExpressions finIntitule ;
//======================= sections =======================================
lesSections : chapitre | paragraphe | sousParagraphe
            | sousSousParagraphe ;

chapitre
:  LE_CHAPITRE   { maGestionPml.chapitre(); }
   L_ACCOLADE (caractereComplet | uneFormule)+
            rAccolade
         { maGestionPml.finSections(Globale.PAR_CHAPITRE); }
;
paragraphe
:  LA_SECTION  { maGestionPml.paragraphe(); }
   L_ACCOLADE (caractereComplet | uneFormule)+ rAccolade
    { maGestionPml.finSections(Globale.PAR_PARAGRAPHE); }
;
sousParagraphe
:  LA_SSECTION { maGestionPml.sousParagraphe(); }
   L_ACCOLADE (caractereComplet | uneFormule)+ rAccolade
       { maGestionPml.finSections(Globale.PAR_SS_PARAGRAPHE); } ;
sousSousParagraphe
:  LA_SSSECTION { maGestionPml.sousSousParagraphe(); }
   L_ACCOLADE (caractereComplet | uneFormule)+ rAccolade
       { maGestionPml.finSections(Globale.PAR_SS_SS_PARAGRAPHE); } ;

//======================= references =======================================
lesReferences
   :  reference | citation | label | source  ;

reference   :  { maGestionPml.avantUneReference(); } REF
               chainePure
               rAccolade     { maGestionPml.reference(); } ;
citation    :  { maGestionPml.avantUneReference(); } CITE
               chainePure
               rAccolade      { maGestionPml.citation(); } ;
label       :  { maGestionPml.avantUneReference(); } LABEL
               chainePure
               rAccolade         { maGestionPml.label(); } ;
source      :  { maGestionPml.avantUneReference(); } SOURCE
               chainePure
               rAccolade        { maGestionPml.source(); } ;
//======================= listes ============================
//lesListes : listeNumerotee | listeItemisee;
/*
listeNumerotee :  LISTE_NUMEROTEE
                  listExpressions
                  FIN_LISTE_NUMEROTEE  ;
listeItemisee :   LISTE_ITEMISE
                  listExpressions
                  FIN_LISTE_ITEMISE  ;
*/
item : ITEM ;
//========= separateurs ===========
ressort  :  RESSORT           { maGestionPml.ressort(); } ;
//======================== formules ==============================
//=============== base maths=======================
caractereMath
:  caractere | caractereAccentue | blanc | blancForce// | leRetourTexte
|  lettreAccentue | caracteresMathML
|  lesReferences
|  caracteresGrecs | caracteresGrecsMaj |caracteresGrecsDirects
|  lesFaussesBbb | lesFaussesBbbDirects
| caracteresMaths | caracteresMath2 | caracteresMathsDirects
| caracteresMath2Directs
| caracteresItaliques | accentueMath
| lesReserves | overline
| tailleScript
| ressort
| lesRaccourcis
;

basiqueMath : lesSymboles | caractereMath
            | chainePureSoulignee | chainePurePoliceeEmpilee
            | listeDeChaines | expressionParenthesee
            ;
expressionMath :  (basiqueMath)+ ;
//======== accents maths ===========
accentueMath
: accentGraveMath | accentTildeMath | accentAiguMath | accentCirconflexeMath
| accentTremaMath | accentPointMath | accentTchecheMath | accentBarreMath
| accentBreveMath
;

accentGraveMath
   :  ACCENT_GRAVE_MATH    { maGestionPml.accentueMath(); }
      caractere            { maGestionPml.accentGraveMath(); } ;
accentTildeMath : ACCENT_TILDE_MATH    { maGestionPml.accentueMath(); }
                  caractereMath            { maGestionPml.accentTildeMath(); } ;
accentAiguMath :  ACCENT_AIGU_MATH     { maGestionPml.accentueMath(); }
                  caractereMath            { maGestionPml.accentAiguMath(); } ;
accentCirconflexeMath : ACCENT_CIRCONFLEXE_MATH { maGestionPml.accentueMath(); }
                        caractereMath   { maGestionPml.accentCirconflexeMath(); } ;
accentTremaMath : ACCENT_TREMA_MATH    { maGestionPml.accentueMath(); }
                  caractereMath            { maGestionPml.accentTremaMath(); } ;
accentPointMath : ACCENT_POINT_DESSUS_MATH   { maGestionPml.accentueMath(); }
                  caractereMath                  { maGestionPml.accentPointMath(); } ;
accentTchecheMath : ACCENT_TCHECHE_MATH      { maGestionPml.accentueMath(); }
                    caractere            { maGestionPml.accentTchecheMath(); } ;
accentBarreMath : ACCENT_BARRE_DESSUS_MATH   { maGestionPml.accentueMath(); }
                  caractereMath            { maGestionPml.accentBarreMath(); } ;
accentBreveMath : ACCENT_BREVE_MATH    { maGestionPml.accentueMath(); }
                  caractereMath            { maGestionPml.accentBreveMath(); } ;
//======== fin accents maths ===========
overline :  OVERLINE                   { maGestionPml.overline(); }
            expressionParenthesee
                                       { maGestionPml.finOverline(); };
//======================== symboles ==============================
lesSymboles
   :  lesMonos | lesTrios | matrice | lesDuos
   ;
lesSymbolesSansIndice
   :  lesMonosSansIndice | lesTrios | lesDuos | matrice
   ;
lesMonosSansIndice
   :  racine | parentheses | crochets | accoladeOuvrante | accoladeFermante
   |  parExces | parDefaut | produitScalaire | norme | valeurAbsolue
   |  normeAcc | valeurAbsolueAcc
   ;
expressionParenthesee : L_ACCOLADE expressionMath rAccolade ;
expressionTex : caractereMath | expressionParenthesee ;
//=================== duos ================
/*=========
symboleParenthese
   :        L_ACCOLADE
            ( (               { maGestionPml.fraction(); }  // fraction
                expressionTex { maGestionPml.numerateur(); }
                FRACTION)
                  => expressionTex { maGestionPml.denominateur(); }
            | lesMonos
            | lesTrios
            )
            rAccolade
   ;
===================*/
lesDuos
   :  vraieFraction | underSet | overSet
   ;
vraieFraction
   :  VRAIE_FRACTION          { maGestionPml.fraction(); }
      expressionTex           { maGestionPml.numerateur(); }
      expressionTex           { maGestionPml.denominateur(); }
   ;
underSet
   :  PAR_DESSOUS             { maGestionPml.underSet(); }
      expressionTex           { maGestionPml.numerateur(); }
      L_OBLIQUE
      expressionTex           { maGestionPml.denominateur(); }
   ;
overSet
   :  PAR_DESSUS             { maGestionPml.overSet(); }
      expressionTex           { maGestionPml.numerateur(); }
      L_OBLIQUE
      expressionTex           { maGestionPml.denominateur(); }
   ;
underSetAcc
   :  PAR_DESSOUS_ACC         { maGestionPml.underSet(); }
      expressionTex           { maGestionPml.numerateur(); }
      L_OBLIQUE
      expressionTex           { maGestionPml.denominateur(); }
      rAccolade
   ;
overSetAcc
   :  PAR_DESSUS_ACC          { maGestionPml.overSet(); }
      expressionTex           { maGestionPml.numerateur(); }
      L_OBLIQUE
      expressionTex           { maGestionPml.denominateur(); }
      rAccolade
   ;
/*==
fraction :                          { maGestionPml.fraction(); }
            L_ACCOLADE
            expressionTex { maGestionPml.numerateur(); }
            FRACTION
            expressionTex { maGestionPml.denominateur(); }
            rAccolade ;
==*/
//=================== trios ===============
lesTrios
   :  integrale      | somme | union | intersection
   |  produitInfini  |  produitVectoriel
   | integraleAcc    | sommeAcc | unionAcc | intersectionAcc
   |  produitInfiniAcc  |  produitVectorielAcc
   ;
triCorps
: (  (   INDICE_SIMPLE { maGestionPml.entreeBorneInferieure(); }
         caractereMath { maGestionPml.borneInferieure(); }
      )
      |
      (  INDICE   { maGestionPml.entreeBorneInferieure(); }
         (expressionMath)? { maGestionPml.borneInferieure(); }
         rAccolade
      )
   )*
   (  (  EXPOSANT_SIMPLE   { maGestionPml.entreeBorneSuperieure(); }
         caractereMath     { maGestionPml.borneSuperieure(); }
      )
      |
      (  EXPOSANT          { maGestionPml.entreeBorneSuperieure(); }
         (expressionMath)? { maGestionPml.borneSuperieure(); }
         rAccolade
      )
   )*
   (                             { maGestionPml.entreeIntegrant(); }
      (  expressionTex
      |  lesSymbolesSansIndice
      )                          { maGestionPml.integrant(); }
   )                             { maGestionPml.finTrio(); }
;
//============
integrale         :  INTEGRALE { maGestionPml.integrale(); }
                     triCorps ;
integraleAcc      :  INTEGRALE_ACC { maGestionPml.integrale(); }
                     triCorps  R_ACCOLADE ;
somme             :  SOMME { maGestionPml.somme(); }
                     triCorps  ;
sommeAcc          :  SOMME_ACC { maGestionPml.somme(); }
                     triCorps  R_ACCOLADE ;
produitInfini     :  PROD_INFINI { maGestionPml.produitInfini(); }
                     triCorps  ;
produitInfiniAcc  :  PROD_INFINI_ACC { maGestionPml.produitInfini(); }
                     triCorps  R_ACCOLADE ;
produitVectoriel  :  PROD_VECTORIEL { maGestionPml.produitVectoriel(); }
                     triCorps  ;
produitVectorielAcc :  PROD_VECTORIEL_ACC { maGestionPml.produitVectoriel(); }
                     triCorps  R_ACCOLADE ;
union             :  UNION { maGestionPml.union(); }
                     triCorps  ;
unionAcc          :  UNION_ACC { maGestionPml.union(); }
                     triCorps  R_ACCOLADE ;
intersection      :  INTERSECTION { maGestionPml.intersection(); }
                     triCorps  ;
intersectionAcc   :  INTERSECTION_ACC { maGestionPml.intersection(); }
                     triCorps  R_ACCOLADE ;
//=================== matrice ================
matrice  :  MATRICE           { maGestionPml.matrice(); }
            expressionMath
           (entreeMatrice)*
           finMatrice
         ;
//ligneMatrice : (entreeMatrice)*
//               expressionMath
//               FIN_LIGNE_CR { maGestionPml.finLigneMatrice(); }
//             ;
entreeMatrice : (esperluete | finLigneMatrice)
                expressionMath
              ;
finMatrice :  FIN_MATRICE  { maGestionPml.finMatrice(); } ;
//finMatrice :  FIN_LIGNE_CR
  //             R_PAREN  { maGestionPml.finMatrice(); } ;

esperluete        :  ESPERLUETE        { maGestionPml.esperluete(); } ;
finLigneMatrice   :  FIN_LIGNE_CR { maGestionPml.finLigneMatrice(); } ;
//================ tableaux ===========
tableau  :  TABLEAU L_ACCOLADE chainePure rAccolade
            finTableau
         ;
finTableau :  FIN_TABLEAU  { maGestionPml.finTableau(); } ;
esperlueteTableau :  ESPERLUETE  { maGestionPml.esperlueteTableau(); } ;
finLigneTableau   :  FIN_LIGNE_CR { maGestionPml.finLigneTableau(); } ;
//=================== raccourcis ===========
lesRaccourcis
   :  limite// , vielleFraction
   ;
limite         : LIMITE {maGestionPml.ecritLimite(); } ;
//vielleFraction : FRACTION {maGestionPml.ecritFraction(); } ;
//=================== monos ================
lesMonos
   :  racine | parentheses | crochets | accoladeOuvrante | accoladeFermante
   |  parExces | parDefaut | produitScalaire | norme | normeAcc
   | valeurAbsolue | valeurAbsolueAcc
   | exposantSimple | exposant | indiceSimple | indice ;
//=============
finMono : expressionMath rAccolade { maGestionPml.finMono(); } ;
corps : (caractereCompletMath { maGestionPml.monoCar(); })
      | ( expressionParenthesee { maGestionPml.finMono(); } )
      ;
corpsSimple : expressionMath { maGestionPml.finMono(); } ;
//========== indice exposant ====
exposantSimple : EXPOSANT_SIMPLE { maGestionPml.entreeExposant(); }
                 caractereComplet { maGestionPml.exposantSimple(); } ;
//exposantSimple : EXPOSANT_SIMPLE { maGestionPml.entreeExposant(); }
  //               caractereMath { maGestionPml.exposantSimple(); } ;
exposant : EXPOSANT { maGestionPml.exposant(); }
           expressionMath rAccolade { maGestionPml.finMono(); } ;
//indiceSimple : INDICE_SIMPLE { maGestionPml.entreeIndice(); }
  //             caractereMath { maGestionPml.indiceSimple(); } ;
indiceSimple : INDICE_SIMPLE { maGestionPml.entreeIndice(); }
               caractereComplet { maGestionPml.indiceSimple(); } ;
indice : INDICE { maGestionPml.indice(); }
           expressionMath rAccolade { maGestionPml.finMono(); } ;
//========== autres monos ====
racine      :  RACINE { maGestionPml.racine(); } corps ;
parentheses :  PARENT_GAUCHE { maGestionPml.parentheses(); }
               corpsSimple PARENT_DROITE ;
crochets    :  CROCHET_GAUCHE { maGestionPml.crochets(); }
               corpsSimple CROCHET_DROIT ;
accoladeOuvrante  :  ACCOLADE_OUVRANTE { maGestionPml.accoladeOuvrante(); }
                     corpsSimple OUVRANTE_FIN ;
accoladeFermante  :  FERMANTE_DEBUT { maGestionPml.accoladeFermante(); }
                     corpsSimple ACCOLADE_FERMANTE ;
parExces          :  EXCES_GAUCHE { maGestionPml.parExces(); }
                     corpsSimple EXCES_DROIT ;
parDefaut         :  DEFAUT_GAUCHE { maGestionPml.parDefaut(); }
                     corpsSimple DEFAUT_DROIT ;
produitScalaire   :  PROD_SCAL_GAUCHE { maGestionPml.produitScalaire(); }
                     corpsSimple PROD_SCAL_DROIT ;
norme             :  NORME_GAUCHE { maGestionPml.norme(); }
                     corpsSimple NORME_DROITE ;
normeAcc          :  NORME_GAUCHE_ACC { maGestionPml.norme(); }
                     corpsSimple NORME_DROITE R_ACCOLADE ;
valeurAbsolue     :  VALEUR_ABS_GAUCHE { maGestionPml.valeurAbsolue(); }
                     corpsSimple VALEUR_ABS_DROITE ;
valeurAbsolueAcc  :  VALEUR_ABS_GAUCHE_ACC { maGestionPml.valeurAbsolue(); }
                     corpsSimple VALEUR_ABS_DROITE R_ACCOLADE ;
//========================
//========================= genres Formules =============
uneFormule : petiteFormule | formuleNumerotee | formuleStandard ;
petiteFormule
   :  PETITE_FORMULE { maGestionPml.petiteFormule(); }
      expressionMath
      PETITE_FORMULE   { maGestionPml.finFormule(); }
   ;
   exception
   catch[RecognitionException ex] {
      System.err.println("Une 4 exception: " + ex);
   }
/*====
petiteFormule
   :
            PETITE_FORMULE { maGestionPml.petiteFormule(); }
            ( (expressionMath FRACTION) =>   { maGestionPml.fraction(); }
                     expressionMath { maGestionPml.numerateur(); }
                     FRACTION
                     expressionMath { maGestionPml.denominateur(); }
               |  expressionMath )
            PETITE_FORMULE   { maGestionPml.finFormule(); }
   ;
*
formule
   :  ( (PETITE_FORMULE PETITE_FORMULE) =>
            { maGestionPml.formuleStandard(); }
            expressionMath
            PETITE_FORMULE PETITE_FORMULE
            { maGestionPml.finFormule(); }
         |
            purePetiteFormule
         )
   ;
*/
formuleStandard
   :  FORMULE_STANDARD { maGestionPml.formuleStandard(); }
      expressionMath
      FORMULE_STANDARD { maGestionPml.finFormule(); }
   ;
   exception
   catch[RecognitionException ex] {
      System.err.println("Une 4 exception: " + ex);
   }
formuleNumerotee
   :  FORMULE_NUMEROTEE          { maGestionPml.formuleNumerotee(); }
      expressionMath
      (FINPARAG)*
      FIN_FORMULE_NUMEROTEE      { maGestionPml.finFormule(); }
   ;
   exception
   catch[RecognitionException ex] {
      System.err.println("Une 4 exception: " + ex);
   }
//======================= fin du parser =======================================
//======================= fin du parser =======================================
//======================= fin du parser =======================================
//======================= fin du parser =======================================
//======================= fin du parser =======================================

class TexToPmlLexer extends Lexer;
options {
   k = 25;
//	charVocabulary = '\3'..'\177';
}
{  boolean enPf = false;
}

//======== mots reserves par TeX ==========
DEBUT_DOCUMENT  : "\\begin{document}"  ;
FIN_DOCUMENT    : "\\end{document}"  ;
LE_END          : "\\end"  ;

TABLEAU     :  "\\begin{tabular}" ;
FIN_TABLEAU :  "\\end{tabular}" ;

LE_BEGIN_PAR    :	"\\begin{"  ;
LE_END_PAR      :	"\\end{"    ;

R_ACCOLADE     :  "}"         ;
L_ACCOLADE     :  "{"         ;

RESSORT     :  "\\hfill"   ;

//=== caracteres particuliers =============
LIGNE_CENTREE  :  "\\centerline{" ;
FINPARAG       :	"\\par"         ;
ITEM           :	"\\item"        ;
UNDERLINE      :  "\\underbar"
               |  "\\underline"   ;

//=== Latex ===============================

LE_TITRE    :	"\\title{"           ;
L_AUTEUR	   :  "\\author{"          ;
LA_DATE     :	"\\date{"            ;
//RESUME      :  "\\begin{abstract}"  ;
//FIN_RESUME  :  "\\end{abstract}"  ;
// LE_SOMMAIRE :	"\\tableofcontents"  ;

LE_CHAPITRE       :	"\\chapter"          ;
LA_SECTION        :	"\\section"          ;
LA_SSECTION       :	"\\subsection"       ;
LA_SSSECTION      :	"\\subsubsection"    ;

LABEL             :	("\\label{" | "~\\label{")  ;
REF               :	("\\ref{"   | "~\\ref{" )    ;
CITE              :	("\\cite{"  | "~\\cite{")    ;
SOURCE            :	"\\bibitem{"          ;
//==================== formule ============================

PETITE_FORMULE          :  "$"   { if(enPf)
                                       enPf = false;
                                    else
                                       enPf = true;
                                 }
                        ;
FORMULE_STANDARD        :   "$$" { if(enPf)
                                       enPf = false;
                                    else
                                       enPf = true;
                                 }
                        ;
FORMULE_NUMEROTEE      :  "\\begin{equation}" {enPf = true;}
                       ;
FIN_FORMULE_NUMEROTEE  :  "\\end{equation}"   {enPf = false;}
                       ;
/*
LISTE_NUMEROTEE         :  "\\begin{enumerate}"   ;
FIN_LISTE_NUMEROTEE     :  "\\end{enumerate}"   ;
LISTE_ITEMISE           :  "\\begin{itemize}"   ;
FIN_LISTE_ITEMISE       :  "\\end{itemize}"   ;
*/
OVERLINE          :  "\\overline"      ;

EXPOSANT_SIMPLE   :  "^"  ;
INDICE_SIMPLE     :  "_"  ;
EXPOSANT  :  "^{" ;
INDICE    :  "_{" ;
//========================= mono ===========================
PARENT_GAUCHE        :  "\\left("         ;  //'('
PARENT_DROITE        :  "\\right)"        ;
CROCHET_GAUCHE       :  "\\left["         ;  //'['
CROCHET_DROIT        :  "\\right]"        ;
ACCOLADE_OUVRANTE    :  "\\left\\lbrace"  ;  //'{'
OUVRANTE_FIN         :  "\\right."        ;
FERMANTE_DEBUT       :  "\\left."         ;
ACCOLADE_FERMANTE    :  "\\right\\rbrace" ;
EXCES_GAUCHE         :  "\\left\\lceil"   ;  //'a'
EXCES_DROIT          :  "\\right\\rceil"  ;
DEFAUT_GAUCHE        :  "\\left\\lfloor"  ;  //'e'
DEFAUT_DROIT         :  "\\right\\rfloor" ;
PROD_SCAL_GAUCHE     :  ("\\left\\langle"  | "\\langle") ;  //'G'
PROD_SCAL_DROIT      :  ("\\right\\rangle" | "\\rangle") ;
NORME_GAUCHE         :  "\\left\\Vert"    ;  //'n'
NORME_GAUCHE_ACC     :  "{\\left\\Vert"    ;  //'n'
NORME_DROITE         :  "\\right\\Vert"   ;
RACINE               :  "\\sqrt"          ;  //'r'
VALEUR_ABS_GAUCHE    :  "\\left\\vert"    ;  //'v'
VALEUR_ABS_GAUCHE_ACC    :  "{\\left\\vert"    ;  //'v'
VALEUR_ABS_DROITE    :  "\\right\\vert"   ;

//========================= duo ============================
FRACTION         :  "\\over"          ;

VRAIE_FRACTION    :  "\\frac"    ;
PAR_DESSUS        :  "\\buildrel" ;
PAR_DESSOUS       :  "\\buildreb" ;
PAR_DESSUS_ACC    :  "{\\buildrel" ;
PAR_DESSOUS_ACC   :  "{\\buildreb" ;
//========================= trio ===========================

INTEGRALE         :  "\\int"     ;
SOMME             :  "\\sum"     ;
PROD_INFINI       :  "\\prod"    ;
PROD_VECTORIEL	   :  "\\bigwedge" ;
UNION             :  "\\bigcup"  ;
INTERSECTION      :  "\\bigcap"  ;

INTEGRALE_ACC     :  "{\\int"     ;
SOMME_ACC         :  "{\\sum"     ;
PROD_INFINI_ACC   :  "{\\prod"    ;
PROD_VECTORIEL_ACC :  "{\\bigwedge" ;
UNION_ACC         :  "{\\bigcup"  ;
INTERSECTION_ACC  :  "{\\bigcap"  ;
/*
LEFT              :  "\\left"    ;
RIGHT             :  "\\right"   ;
*/
//======= matrice ===========
//NOUV_LIGNE        : "\r\n" {newline();} ;
MATRICE           :  ("\\matrix{" | "\\matrix {"| "\\matrix\r\n{" {newline();}
                     | "\\matrix\r\n {" {newline();}
                     | "\\matrix \r\n{" {newline();}) ;
ESPERLUETE        :  "&"         ;
FIN_LIGNE_CR :  "\\cr\r\n" {newline();} ;
//FIN_LIGNE_CR : ("\\cr" | "\\cr\r\n" {newline();} )     ;
//FIN_MATRICE_BIS   :  "\\cr\r\n }"  {newline();} ;
FIN_MATRICE       :  FIN_LIGNE_CR "}"  ;
//CE_ERRE           :  "\\cr" ;
//================ polices permanentes ============

ROMAN          :  "\\rm"   ;
BLACKBOARD     :  "\\Bbb"  ;
ITALIC         :  "\\it"   ;
GOTHIC         :  "\\goth" ;
CALLIGRAPHIC   :  "\\cal"  ;
//TYPEWRITER     :  "\\tt"   ;
SMALLCAP       :  ("\\sc" | "\\Ptm")  ;
CYRILLIC       :  "\\cyr"  ;

//============= polices maths permanentes ===========

MATHS         :  "\\mt{"  ;

BATHS         :  "\\mt2{" ;

GRECS         :  "\\gr{"  ;

BBB           :  "\\fbb{" ;

//============= attributs polices  =================
BOLDFACE_TEX   :  "\\bf"      ;
SLANTED_TEX    :  "\\sl"      ;
//============== tailles ===================
TAILLE_SCRIPT  :  "\\scriptstyle" ;

//================ polices math ============
PL_BLACKBOARD_EMP :  "{\\Bbb"    ;
L_BLACKBOARD_EMP  :  "\\textbb{"
                  |  "\\mathbb{"   ;
//================ polices empilees ============
PL_ROMAN_EMP      : "{\\rm"      ;
L_ROMAN_EMP       :  "\\textrm{"
                  |  "\\mathrm{" ;
PL_ITALIC_EMP     :  "{\\it"     ;
L_ITALIC_EMP      :  "\\textit{"
                  |  "\\mathit{" ;
PL_GOTHIC_EMP     :	"{\\goth"   ;
L_GOTHIC_EMP      :  "\\mathfrak{" ;

PL_CALLIGRAPHIC_EMP  :	"{\\cal"      ;
L_CALLIGRAPHIC_EMP   :	"\\mathcal{"      ;

//PL_TYPEWRITER_EMP    :	"{\\tt"       ;
//L_TYPEWRITER_EMP     :  "\\texttt{"
  //                   |  "\\mathtt{"       ;
PL_SMALLCAP_EMP   :	"{\\sc"
	               |  "{\\Ptm" ;
L_SMALLCAP_EMP    :  "\\textsc{"
                  |  "\\mathsc{"  ;
CYRILLIC_EMP	   :  "{\\cyr"       ;
//============= formes polices =================
PL_GRASSE_EMP  :  "{\\bf"        ;
L_GRASSE_EMP   :  "\\textbf{"
               |  "\\mathbf{"    ;

PL_PENCHEE_EMP :  "{\\sl"     ;
L_PENCHEE_EMP  :  "\\textsl{"
               |  "\\mathsl{" ;
L_GRASSE_PENCHEE_EMP   :  "\\textbf{\\textsl{"    ;
L_PENCHEE_GRASSE_EMP   :  "\\textsl{\\textbf{"    ;
PL_GRASSE_PENCHEE_EMP   :  "{\\bf{\\sl "    ;
PL_PENCHEE_GRASSE_EMP   :  "{\\sl{\\bf "    ;
//=================== lettres accentues ========================
LE_MOINS       :  ("{\\tt -}" | "{\\tt\r\n -}" {newline();}
                   | "{\\tt \r\n-}" {newline();});
A_GRAVE        : "\\`a" ;
A_AIGU         : "\\\'a" ;
A_CIRCONFLEXE  : "\\^a" ;
A_TILDE        : "\\~a" ;
A_TREMA        : "\\\"a" ;
A_ROND         : "\\.a" ;

E_GRAVE        : "\\`e" ;
E_AIGU         : "\\\'e" ;
E_CIRCONFLEXE  : "\\^e" ;
E_TREMA        : "\\\"e" ;

I_GRAVE        : ("\\`i" | "\\`\\i")   ;
I_AIGU         : ("\\\'i" | "\\\'\\i") ;
I_CIRCONFLEXE  : ("\\^i"  | "\\^\\i")  ;
I_CIRCONFLEXE_PAR :  "{\\^\\i}" ;
I_TREMA        : ("\\\"i" | "{\\\"i}" | "\\\"\\i" | "{\\\"\\i}") ;

O_GRAVE        : "\\`o" ;
O_AIGU         : "\\\'o" ;
O_CIRCONFLEXE  : "\\^o" ;
O_TILDE        : "\\~o" ;
O_TREMA        : "\\\"o" ;

U_GRAVE        : "\\`u" ;
U_AIGU         : "\\\'u" ;
U_CIRCONFLEXE  : "\\^u" ;
U_TREMA        : "\\\"u" ;

C_CEDILLE      :  ("\\c c" | "{\\c c}" | "\\c\r\nc" {newline();}) ;
N_TILDE        :  "\\~n" ;

AM_GRAVE        : "\\`A" ;
AM_AIGU         : "\\\'A" ;
AM_CIRCONFLEXE  : "\\^A" ;
AM_TILDE        : "\\~A" ;
AM_TREMA        : "\\\"A" ;
AM_ROND         : "\\.A" ;

EM_GRAVE        : "\\`E" ;
EM_AIGU         : "\\\'E" ;
EM_CIRCONFLEXE  : "\\^E" ;
EM_TREMA        : "\\\"E" ;

IM_GRAVE        : "\\`I" ;
IM_AIGU         : "\\\'I" ;
IM_CIRCONFLEXE  : "\\^I" ;
IM_TREMA        : "\\\"I" ;

OM_GRAVE        : "\\`O" ;
OM_AIGU         : "\\\'O" ;
OM_CIRCONFLEXE  : "\\^O" ;
OM_TILDE        : "\\~O" ;
OM_TREMA        : "\\\"O" ;

UM_GRAVE        : "\\`U" ;
UM_AIGU         : "\\\'U" ;
UM_CIRCONFLEXE  : "\\^U" ;
UM_TREMA        : "\\\"U" ;

CM_CEDILLE      :  "\\c C" ;
NM_TILDE        :  "\\~N" ;
//===================  fin lettres accentues ========================

ACCENT_GRAVE         :  "\\`"    ;
ACCENT_AIGU          :  "\\\'"   ;
ACCENT_CIRCONFLEXE   :  "\\^"    ;
ACCENT_TREMA         :  "\\\""   ;
ACCENT_TILDE         :  "\\~"    ;
ACCENT_CEDILLE       :  "\\c"   ;
ACCENT_POINT_DESSUS  :  "\\."    ;
ACCENT_POINT_DESSOUS :  "\\d"   ;
ACCENT_UMLAUT        :  "\\H"   ;
ACCENT_TCHECHE       :  "\\v"   ;
ACCENT_BARRE_DESSUS  :  "\\="    ;
ACCENT_BARRE_DESSOUS :  "\\b"   ;

//=== accents maths ==========

ACCENT_GRAVE_MATH         :  "\\grave"   ;
ACCENT_AIGU_MATH          :  "\\acute"  ;
ACCENT_CIRCONFLEXE_MATH   :  ("\\hat" | "\\widehat") ;
ACCENT_TREMA_MATH         :  "\\ddot"    ;
ACCENT_TILDE_MATH         :  "\\tilde"   ;
ACCENT_POINT_DESSUS_MATH  :  "\\dot"     ;
ACCENT_TCHECHE_MATH       :  "\\check"   ;
ACCENT_BARRE_DESSUS_MATH  :  "\\bar"     ;
ACCENT_BREVE_MATH         :  "\\breve"   ;

//============ grec ===========================
A_GREC   : "\\alpha" ;
B_GREC   : "\\beta" ;
C_GREC   : ("\\chi" | "\\chi\r\n" {newline();} ) ;
D_GREC   : "\\delta" ;
E_GREC   : "\\epsilon" ;
EE_GREC  : "\\varepsilon" ;
F_GREC   : "\\phi" ;
FF_GREC  : "\\varphi" ;
G_GREC   : "\\gamma" ;
H_GREC   : "\\eta" ;
I_GREC   : "\\iota" ;
K_GREC   : "\\kappa" ;
L_GREC   : "\\lambda" ;
M_GREC   : "\\mu" ;
N_GREC   : "\\nu" ;
P_GREC   : "\\pi" ;
Q_GREC   : "\\psi" ;
R_GREC   : "\\rho" ;
RR_GREC  : "\\varrho" ;
S_GREC   : "\\sigma" ;
SS_GREC  : "\\varsigma" ;
T_GREC   : "\\tau"     ;
TT_GREC  : "\\theta"   ;
TTT_GREC : "\\vartheta"   ;
U_GREC   : "\\upsilon" ;
W_GREC   : "\\omega" ;
X_GREC   : "\\xi" ;
Z_GREC   : "\\zeta" ;
// majuscules
GM_GREC   : "\\Gamma" ;
DM_GREC   : "\\Delta" ;
TM_GREC   : "\\Theta" ;
LM_GREC   : "\\Lambda" ;
PM_GREC   : "\\Pi" ;
XM_GREC   : "\\Xi" ;
SM_GREC   : "\\Sigma" ;
UM_GREC   : "\\Upsilon" ;
FM_GREC   : "\\Phi" ;
QM_GREC   : "\\Psi" ;
WM_GREC   : "\\Omega" ;
//============== fausses Bbb ==================
UN_BBB   : "\\11" ;
A_BBB    : "\\AA" ;
B_BBB    : "\\BB" ;
C_BBB    : "\\CC" ;
D_BBB    : "\\DD" ;
E_BBB    : "\\EE" ;
F_BBB    : "\\FF" ;
G_BBB    : "\\GG" ;
H_BBB    : "\\HH" ;
I_BBB    : "\\II" ;
J_BBB    : "\\JJ" ;
K_BBB    : "\\KK" ;
L_BBB    : "\\LL" ;
M_BBB    : "\\MM" ;
N_BBB    : "\\NN" ;
O_BBB    : "\\OO" ;
P_BBB    : "\\PP" ;
Q_BBB    : "\\QQ" ;
R_BBB    : "\\RR" ;
S_BBB    : "\\SS" ;
T_BBB    : "\\TT" ;
U_BBB    : "\\UU" ;
V_BBB    : "\\VV" ;
W_BBB    : "\\WW" ;
X_BBB    : "\\XX" ;
Y_BBB    : "\\YY" ;
Z_BBB    : "\\ZZ" ;
//==================== maths ==================
//EXPONENTIELLE   :  "\\exp"           ;
LIMITE            :  "\\lim"           ;


APPARTIENT     :  "\\in"            ;
DIFFERENT      :  "\\not="          ;
CROIX          :  "\\times"         ;
D_PARTIELLE    :  "\\partial"       ;
IL_EXISTE      :  "\\exists"        ;
CONTIENT       :  "\\ni"            ;
CROIX_ROND     :  "\\otimes"        ;
INTERSECTION_CAR  :  "\\cap"        ;  //i
CONTIENT_ENS      :  "\\supset"     ;  //j
NON_IDENTIQUE     :  "\\not\\equiv" ;  //n
INFINI            :  "\\infty"      ;  //o
PAS_DEDANS        :  "\\not\\in"    ;  //r
ORTHOGONAL        :  "\\perp"       ;  //s
LE_T              :  "\\top"        ;  //t
UNION_CAR         :  "\\cup"        ;  //u
POUR_TOUT         :  "\\forall"     ; //v
POINT_CENTRE      :  "\\cdot"       ; //,
POINT_VERTICAL    :  "\\vdot"       ; //,
SIMILAIRE         :  "\\simeq"      ; //;
SEMBLABLE         :  "\\sim"      ; //;
ROND_CENTRE       :  "\\circ"       ; //.
BARRE_VERTICALE   :  ("\\mid" | "\\vert") ; //!
DBARRE_VERTICALE  :  "\\Vert"       ; //5
BOULETTE          :  ("\\bullet" | "\\bull")     ; //)
INF_EGAL          :  "\\leq"              ; //<
PLUS_MOINS        :  "\\pm" ;
LE_GROS           :  "\\Big" ;
INCLUSION         :  "\\subset"  ;
SUP_EGAL          :  "\\geq"  ;
EQUIVALENT        :  "\\equiv" ;
VIDE              :  "\\emptyset" ;
EXTERIEUR         :  "\\wedge" ;
BIG_TRIANGLE_UP   :  "\\bigtriangleup" ;
TROIS_POINTS      :  "\\dots" ;
ELL               :  "\\ell" ;
NABLA             :  "\\nabla" ;
INF_TILDA         :  "{\\mathcode\"2E=\"712E\\usA .}" ;
//======== math2 =========
FLECHE_SE         :  "\\searrow" ;
FLECHE_SW         :  "\\swarrow" ;
FLECHE_NE         :  "\\nearrow" ;
FLECHE_NW         :  "\\nwarrow" ;
FLECHE_VERS       :  "\\longmapsto" ;
FLECHE_DROITE     :  "\\longrightarrow"   ;
IMPLICATION       :  "\\Rightarrow" ;
EQUIVALENCE       :  "\\Leftrightarrow" ;
//=========== divers =======
//===========
ESPACE            :  ("\\espace" | "\\;");
BACKSLASH         :  "\\backslash" ;
//==================== reserves ================
ACC_OUVRANTE_RESERVE : "\\{" ;
ACC_FERMANTE_RESERVE : "\\}" ;
POUR_CENT            : "\\%" ;
LE_DIEZE             : "\\#" ;
//==================== MathML ================
INFERIEUR      :  "<" ;
SUPERIEUR      :  ">" ;
L_OBLIQUE      :  "/" ;
//========== a virer ========
BLANC_NEGATIF  :  "\\!" ;
//==================== special ================
//LE_RETOUR            :  "\r\n" {newline();} ;

// Whitespace -- ignored
WS :  (  '\t'
      |  '\f'
// handle newlines
      |  (  "\r\n" {newline();}   // Evil DOS
      |  '\r' {newline();}     // Macintosh
      |  '\n'  {newline();}  // Unix (the right way)
         )
      )  { _ttype = Token.SKIP; }
   ;

// Single-line comments
SL_COMMENT
	:	"%"
		(~('\n'|'\r'))* ('\n'|'\r'('\n')?)
		{$setType(Token.SKIP); }
	;
A_REJETER
   :  ( "\\vspace{-\\baselineskip}"
      | "\\maketitle"
      | "\\displaystyle"
      | "$\\square $"
      | "$ \\square $"
      | "\\vfill\\eject"
      | "{\\hskip9pt}" | "{\\hskip15pt}" | "{\\hskip18pt}"
      | "{\\hskip33pt}"
      | "{\\tt -}\\it" | "{\\hskip30pt}" | "{-\\baselineskip}"
      | "\\begin{enumerate}" | "\\begin{itemize}"
      | "\\end{enumerate}" | "\\end{itemize}" | "\\leftskip"
      | "\\setcounter{equation}{0}"
      | "\\setcounter{equation} {0}"
      | "\\tableofcontents"
      ) { $setType(Token.SKIP); } ;

//BLANC_FORCE :	("\\ "| "\\\r\n" {newline();} ) { if(!enPf) $setType(Token.SKIP); } ;
BLANC       :  ' '    { if(enPf) $setType(Token.SKIP); } ;

//BLANC       :  (' ' | "\\\r\n" {newline();} )
  //                            { if(enPf) $setType(Token.SKIP); } ;
BLANC_FORCE : ("\\ " | "\\," | "\\\r\n" {newline();} );
//BLANC_FORCE : ("\\ " | "\\\r\n" {newline();} );
CONTRE_OBLIQUE  : '\\'
  { if(enPf)
      throw new SemanticException("En formule, ligne no " + getLine(),
                                       getFilename(), getLine());
   else if(!enPf)
      throw new SemanticException("Hors formule, ligne no " + getLine(),
                                       getFilename(), getLine());
    } ;
CARACTERE
:  '!'
| '\"'
| '\''..'.'
| '0'..';'
| '='
| '?'..'['
| ']'
| '`'..'z' ;

//CARACTERE_RESERVE  :  '&' | '~'  ;
CARACTERE_DIEZE    : '#' ;
CARACTERE_ACCENTUE : '\u00A1'..'\u00FF' ;
